<html devsite="">
<head>
  <title>Video and Codelab Tutorials</title>
  <meta name="project_path" value="/_project.yaml">
  <meta name="book_path" value="/_book.yaml">
</head>

<body>
  {% include "_versions.html" %} <!--
      Copyright 2018 The Android Open Source Project

      Licensed under the Apache License, Version 2.0 (the "License");
      you may not use this file except in compliance with the License.
      You may obtain a copy of the License at

          http://www.apache.org/licenses/LICENSE-2.0

      Unless required by applicable law or agreed to in writing, software
      distributed under the License is distributed on an "AS IS" BASIS,
      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
      See the License for the specific language governing permissions and
      limitations under the License.
  -->


  <p>The Vendor Test Suite (VTS) codelabs and video tutorials provide details
  on running and developing VTS and CTS-on-GSI on Android {{
  androidPVersionNumber }} and Android 8.1.</p>

  <h2> Videos and Codelabs for Android 9</h2>

  <table>
    <tr>
      <th>Subject</th>

      <th>Topic</th>

      <th>Videos</th>

      <th>Codelabs/SAC</th>
    </tr>

    <tr>
      <th>Prologue</th>

      <td><strong>Overview</strong>
      </td>

      <td>Android Vendor Test Suite (Coming Soon)</td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts/#0">Introduction</a>
      </td>
    </tr>


    <tr>
      <th rowspan="2">User Manual</th>

      <td><strong>How to Run VTS and CTS-on-GSI</strong>
      </td>

      <td>How to Run VTS and CTS-on-GSI (Coming Soon)</td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts-8/#1">Build
      and Run a VTS Test Plan</a>
      </td>
    </tr>


    <tr>
      <td><strong>How to Flash GSI</strong>
      </td>

      <td>How to Flash General System Image (Coming Soon)</td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts/#3">Prepare
      a device with GSI for CTS-on-GSI test plan</a>
      </td>
    </tr>


    <tr>
      <th rowspan="3">Vendor Test Framework (VTF)</th>

      <td><strong>Test Framework</strong>
      </td>

      <td>Test Framework Changes (Coming Soon)</td>

      <td><a href=
      "https://source.android.com/compatibility/vts/shell-commands">Test
      Framework on SAC</a>
      </td>
    </tr>


    <tr>
      <td><strong>Test Time Optimization</strong>
      </td>

      <td>Test Time Optimization (Coming Soon)</td>

      <td>--</td>
    </tr>


    <tr>
      <td><strong>Multi-Device Testing</strong>
      </td>

      <td>Multi-Device Tests (Coming Soon)</td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts/#12">Write a
      Multi-Device Test</a>
      </td>
    </tr>


    <tr>
      <th rowspan="2">Basic Test Development</th>

      <td><strong>VTS Tests</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=DVanlGPV0wA&amp;index=4&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva">
      VTS Tests</a>
      </td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts-8/#2">Write
      a VTS Test (Getting Started)</a>
      </td>
    </tr>


    <tr>
      <td><strong>Test Templates</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=O4LuIBzB2y8&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva&amp;index=8">
      Test Templates</a>
      </td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts-8/#3">Choose
      a Template and Write a Customized VTS Test</a>
      </td>
    </tr>


    <tr>
      <th rowspan="4">Develop and Understand HAL Tests</th>

      <td><strong>Conditional Tests</strong>
      </td>

      <td>Conditional Tests (Coming Soon)</td>

      <td>--</td>
    </tr>


    <tr>
      <td><strong>Service Name Aware Testing</strong>
      </td>

      <td>Service name aware HAL (Coming Soon)</td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts/#5">Choose a
      Template and Write a Customized VTS Test</a>
      </td>
    </tr>


    <tr>
      <td><strong>HAL Extension Tests</strong>
      </td>

      <td>HAL Extension Test (Coming Soon)</td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts/#6">Write a
      VTS HAL Extension Test</a>
      </td>
    </tr>


    <tr>
      <td><strong>Framework Backward Compatibility</strong>
      </td>

      <td>Android Framework Backward Compatibility (Coming Soon)</td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts/#7">Write a
      HAL adapter test</a>
      </td>
    </tr>


    <tr>
      <th rowspan="2">Other Interface Tests</th>

      <td><strong>Kernel Testing</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=qWxNFhMM0Lc&amp;index=5&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva">
      Kernel Testing</a>
      </td>

      <td>--</td>
    </tr>


    <tr>
      <td><strong>VNDK Tests</strong>
      </td>

      <td>--</td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts-8/#9">Maintain
      VNDK ABI Test</a>
      </td>
    </tr>


    <tr>
      <th rowspan="2">Non-functional Tests</th>

      <td><strong>Performance Profiling</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=F41dHKYPoic&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva&amp;index=6">
      Performance Testing</a>
      </td>

      <td>
        <a href=
        "https://codelabs.developers.google.com/codelabs/android-vts-8/#5">Write
        a VTS Performance Profiling Test</a>

        <p><a href=
        "https://codelabs.developers.google.com/codelabs/android-vts-8/#4">Measure
        VINTF Performance Using VTS</a>
        </p>
      </td>
    </tr>


    <tr>
      <td><strong>Fuzzing</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=AkQcNb0Mf94&amp;index=10&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva">
      HIDL and HAL Interface Fuzzing</a>
      </td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts-8/#7">Write
      a VTS HIDL HAL Interface Fuzz Test</a>
      </td>
    </tr>


    <tr>
      <th rowspan="4">Vendor Test Infrastructure (VTI)</th>

      <td><strong>Code Coverage</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=tJprsmiTn4g&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva&amp;index=9">
      Coverage Instrumentation and Collection in VTS</a>
      </td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts-8/#6">Measure
      Native Code Coverage Using VTS</a>
      </td>
    </tr>


    <tr>
      <td><strong>Record-and-Replay Tests</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=pwbFCKaldNU&amp;index=11&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva">
      Record-and-Replay Testing</a>
      </td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts-8/#8">Write
      a Record-and-Replay Test</a>
      </td>
    </tr>


    <tr>
      <td><strong>End-to-End Automation</strong>
      </td>

      <td>Automatic Measurement Infrastructure (Coming Soon)</td>

      <td>--</td>
    </tr>


    <tr>
      <td><strong>Dashboard</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=3VwSCYUv2Eo&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva&amp;index=3">
      Continuous Integration Dashboard</a>
      </td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts-8/#10">Build
      a VTS Dashboard and Notification Service</a>
      </td>
    </tr>


    <tr>
      <th rowspan="2">Epilogue</th>

      <td><strong>Partner Engineering</strong>
      </td>

      <td>Treble Readiness (Coming Soon)</td>

      <td>--</td>
    </tr>


    <tr>
      <td><strong>Conclusion</strong>
      </td>

      <td>Call for Contributions (Coming Soon)</td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts/#14">Report
      Issues</a>
      </td>
    </tr>
  </table>

  <h2> Videos and Codelabs for Android 8.1</h2>


  <table>
    <tr>
      <th>Subject</th>

      <th>Topic</th>

      <th>Videos</th>

      <th>Codelabs/SAC</th>
    </tr>

    <tr>
      <th>Prologue</th>

      <td><strong>Overview</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=7BX7oSHc7nk&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva">
      Android Vendor Test Suite (VTS) Products</a>
      </td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts-8/#0">Introduction</a>
      </td>
    </tr>


    <tr>
      <th rowspan="2">User Manual</th>

      <td><strong>How to Run VTS and CTS-on-GSI</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=BOAxwX8khlg&amp;index=2&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva">
      How To Run VTS</a>
      </td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts-8/#1">Build
      and Run a VTS Test Plan</a>
      </td>
    </tr>


    <tr>
      <td><strong>How to Flash GSI</strong>
      </td>

      <td>How to Flash General System Image (Coming Soon)</td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts/#3">Prepare
      a device with GSI for CTS-on-GSI test plan</a>
      </td>
    </tr>


    <tr>
      <th>Vendor Test Framework (VTF)</th>

      <td><strong>Test Framework</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=H6sgKtvyprA&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva&amp;index=7">
      VTS Test Framework</a>
      </td>

      <td><a href=
      "https://source.android.com/compatibility/vts/shell-commands">Test
      Framework on SAC</a>
      </td>
    </tr>

    <tr>
      <th rowspan="2">Basic Test Development</th>

      <td><strong>VTS Tests</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=DVanlGPV0wA&amp;index=4&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva">
      VTS Tests</a>
      </td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts-8/#2">Write
      a VTS Test (Getting Started)</a>
      </td>
    </tr>


    <tr>
      <td><strong>Test Templates</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=O4LuIBzB2y8&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva&amp;index=8">
      Test Templates</a>
      </td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts-8/#3">Choose
      a Template and Write a Customized VTS Test</a>
      </td>
    </tr>

    <tr>
      <th rowspan="2">Other Interface Tests</th>

      <td><strong>Kernel Testing</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=qWxNFhMM0Lc&amp;index=5&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva">
      Kernel Testing</a>
      </td>

      <td>--</td>
    </tr>


    <tr>
      <td><strong>VNDK Tests</strong>
      </td>

      <td>--</td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts-8/#9">Maintain
      VNDK ABI Test</a>
      </td>
    </tr>


    <tr>
      <th rowspan="2">Non-functional Tests</th>

      <td><strong>Performance Profiling</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=F41dHKYPoic&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva&amp;index=6">
      Performance Testing</a>
      </td>

      <td>
        <a href=
        "https://codelabs.developers.google.com/codelabs/android-vts-8/#5">Write
        a VTS Performance Profiling Test</a>

        <p><a href=
        "https://codelabs.developers.google.com/codelabs/android-vts-8/#4">Measure
        VINTF Performance Using VTS</a>
        </p>
      </td>
    </tr>


    <tr>
      <td><strong>Fuzzing</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=AkQcNb0Mf94&amp;index=10&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva">
      HIDL and HAL Interface Fuzzing</a>
      </td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts-8/#7">Write
      a VTS HIDL HAL Interface Fuzz Test</a>
      </td>
    </tr>


    <tr>
      <th rowspan="3">Vendor Test Infrastructure (VTI)</th>

      <td><strong>Code Coverage</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=tJprsmiTn4g&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva&amp;index=9">
      Coverage Instrumentation and Collection in VTS</a>
      </td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts-8/#6">Measure
      Native Code Coverage Using VTS</a>
      </td>
    </tr>


    <tr>
      <td><strong>Record-and-Replay Tests</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=pwbFCKaldNU&amp;index=11&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva">
      Record-and-Replay Testing</a>
      </td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts-8/#8">Write
      a Record-and-Replay Test</a>
      </td>
    </tr>


    <tr>
      <td><strong>Dashboard</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=3VwSCYUv2Eo&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva&amp;index=3">
      Continuous Integration Dashboard</a>
      </td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts-8/#10">Build
      a VTS Dashboard and Notification Service</a>
      </td>
    </tr>


    <tr>
      <th>Epilogue</th>
      <td><strong>Conclusion</strong>
      </td>

      <td><a href=
      "https://www.youtube.com/watch?v=-ydHIqD8-o4&amp;index=12&amp;list=PLWz5rJ2EKKc9JOMtoWWMJHFHgvXDoThva">
      Future Plans</a>
      </td>

      <td><a href=
      "https://codelabs.developers.google.com/codelabs/android-vts-8/#11">Report
      Issues</a>
      </td>
    </tr>
  </table>
</body>
</html>
